unit frmMainU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, Menus, Clipbrd, shellapi, NewCtrls;

type
  TfrmCopyPath = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edtFullPath: TEdit;
    Label2: TLabel;
    edtFilename: TEdit;
    Label3: TLabel;
    edtDos: TEdit;
    btnFullPath: TSpeedButton;
    btnFilename: TSpeedButton;
    btnDos: TSpeedButton;
    GroupBox2: TGroupBox;
    edtB: TEdit;
    Label4: TLabel;
    edtKB: TEdit;
    Label5: TLabel;
    edtMB: TEdit;
    Label6: TLabel;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    edtTime: TEdit;
    Label8: TLabel;
    edtCreateTime: TEdit;
    Label9: TLabel;
    edtAccessTime: TEdit;
    Button1: TButton;
    Button2: TButton;
    btnEasyCopy: TButton;
    Button3: TButton;
    MainMenu1: TMainMenu;
    F1: TMenuItem;
    mnuNotepad: TMenuItem;
    H1: TMenuItem;
    H2: TMenuItem;
    FileDrop1: TFileDrop;
    F2: TMenuItem;
    mnuSelFile: TMenuItem;
    dlgOpenFile: TOpenDialog;
    N1: TMenuItem;
    mnuClose: TMenuItem;
    mnuSendToMake: TMenuItem;
    N3: TMenuItem;
    N2: TMenuItem;
    mnuOpenSendTo: TMenuItem;
    mnuOpenStrtup: TMenuItem;
    mnuOpenMyDocument: TMenuItem;
    procedure btnFullPathClick(Sender: TObject);
    procedure btnFilenameClick(Sender: TObject);
    procedure btnDosClick(Sender: TObject);
    procedure btnEasyCopyClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure mnuNotepadClick(Sender: TObject);
    procedure H2Click(Sender: TObject);
    procedure mnuSelFileClick(Sender: TObject);
    procedure FileDrop1FileDrop(Sender: TObject; Num: Integer;
      Files: TStrings; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure mnuCloseClick(Sender: TObject);
    procedure mnuSendToMakeClick(Sender: TObject);
    procedure mnuOpenSendToClick(Sender: TObject);
    procedure mnuOpenStrtupClick(Sender: TObject);
    procedure mnuOpenMyDocumentClick(Sender: TObject);
  private
    { Private 錾 }
    procedure CopyPath(s: string);
    procedure CheckFile(fname: string);
  public
    { Public 錾 }
  end;

var
  frmCopyPath: TfrmCopyPath;

implementation

uses unit_file, mini_file_utils;

{$R *.dfm}

procedure TfrmCopyPath.btnFullPathClick(Sender: TObject);
begin
  CopyPath(edtFullPath.Text);
end;

procedure TfrmCopyPath.CopyPath(s: string);
begin
  Clipboard.AsText := s;
  ShowMessage('Nbv{[hɈȉ̕Rs[܂B'#13#10+
  s);
end;

procedure TfrmCopyPath.btnFilenameClick(Sender: TObject);
begin
  CopyPath(edtFilename.Text);
end;

procedure TfrmCopyPath.btnDosClick(Sender: TObject);
begin
  CopyPath(edtDos.Text);
end;

procedure TfrmCopyPath.btnEasyCopyClick(Sender: TObject);
begin
  CopyPath(edtKB.Text + #9 + edtFilename.Text);
end;

procedure TfrmCopyPath.Button2Click(Sender: TObject);
var
  s: string;
begin
  s := ExtractFilePath(edtFullPath.Text);
  ShellExecute(Handle, 'open', PChar(s), '','', SW_SHOW);
end;

procedure TfrmCopyPath.Button1Click(Sender: TObject);
var
  s: string;
  os: TOSVersionInfo;
begin
  s := ExtractFilePath(edtFullPath.Text);
  os.dwOSVersionInfoSize := SizeOf(os);
  GetVersionEx(os);

  if os.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS	then
  begin
    ShellExecute(Handle, 'open', 'command.exe', '',PChar(s), SW_SHOW);
  end else
  begin
    ShellExecute(Handle, 'open', 'cmd.exe', '',PChar(s), SW_SHOW);
  end;
end;

procedure TfrmCopyPath.Button3Click(Sender: TObject);
var
  path, s: string;
begin
  s := InputBox('t@C̕ύX', 'Vt@C͂ĂB', edtFilename.Text);
  if s = '' then Exit;
  path := ExtractFilePath(edtFullPath.Text);
  RenameFile(edtFullPath.Text, path + s);
  ShowMessage('ς܂B');
  Close;  
end;

procedure TfrmCopyPath.mnuNotepadClick(Sender: TObject);
var
  s: string;
begin
  s := '"' + edtFullPath.Text + '"';
  ShellExecute(Handle, 'open', 'notepad.exe', PChar(s), '', SW_SHOW);
end;

procedure TfrmCopyPath.H2Click(Sender: TObject);
var
  s: string;
begin
  s := ExtractFilePath(ParamStr(0))+'ReadMe.txt';
  ShellExecute(Handle, 'open', PChar(s),'','',SW_SHOW);
end;

procedure TfrmCopyPath.mnuSelFileClick(Sender: TObject);
begin
  if dlgOpenFile.Execute then
  begin
    CheckFile(dlgOpenFile.FileName);
  end;
end;

procedure TfrmCopyPath.CheckFile(fname: string);
var
  s: string;
  sr: TSearchRec;
  buf: string;
  d: Extended;
  tm: Integer;
  dt: TDateTime; sys: TSystemTime ; ft: TFileTime ;
begin
  //=======================================--
  // Copy Path
  s := fname;
  edtFullPath.Text := s;
  edtFilename.Text := ExtractFileName(s);
  SetLength(buf, MAX_PATH);
  GetShortPathName(PChar(s), PChar(buf), Length(buf));
  edtDos.Text := buf;
  //

  // ڍ׏
  if FindFirst(ParamStr(1), faAnyFile, sr) = 0 then
  begin
    edtB.Text := IntToStr(sr.Size);
    d := sr.Size ;
    d := d / 1024 ;
    edtKB.Text := Format('%.1f',[d]);
    d := d / 1024 ;
    edtMB.Text := Format('%.2f',[d]);
    //
    ft := sr.FindData.ftCreationTime;
    FileTimeToLocalFileTime(ft, ft);
    FileTimeToSystemTime(ft, sys);
    dt := SystemTimeToDateTime(sys);
    edtCreateTime.Text := DateTimeToStr(dt);

    ft := sr.FindData.ftLastAccessTime;
    FileTimeToLocalFileTime(ft, ft);
    FileTimeToSystemTime(ft, sys);
    dt := SystemTimeToDateTime(sys);
    edtAccessTime.Text := DateTimeToStr(dt);

    ft := sr.FindData.ftLastWriteTime;
    FileTimeToLocalFileTime(ft, ft);
    FileTimeToSystemTime(ft, sys);
    dt := SystemTimeToDateTime(sys);
    edtTime.Text := DateTimeToStr(dt);

    //
    FindClose(sr);
  end;

end;

procedure TfrmCopyPath.FileDrop1FileDrop(Sender: TObject; Num: Integer;
  Files: TStrings; X, Y: Integer);
begin
  if Files.Count > 0 then
    CheckFile(Files.Strings[0]);
end;

procedure TfrmCopyPath.FormCreate(Sender: TObject);
begin
  if ParamCount > 0 then
  begin
    CheckFile(ParamStr(1));
  end;
end;

procedure TfrmCopyPath.mnuCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmCopyPath.mnuSendToMakeClick(Sender: TObject);
begin
  CreateShortCut(SendToDir + 't@C擾.lnk', ParamStr(0), '', '', wsNormal);
end;

procedure TfrmCopyPath.mnuOpenSendToClick(Sender: TObject);
begin
  OpenApp(SendToDir);
end;

procedure TfrmCopyPath.mnuOpenStrtupClick(Sender: TObject);
begin
  OpenApp(StartUpDir);
end;

procedure TfrmCopyPath.mnuOpenMyDocumentClick(Sender: TObject);
begin
  OpenApp(MyDocumentDir);
end;

end.
